# -*- coding: UTF-8 -*-
# from keras.utils import plot_model
# from keras.utils.vis_utils import plot_model
from keras import models
from keras import layers
from keras import regularizers

from keras.layers import Activation, Dense, Dropout, Conv2D, Flatten, MaxPooling2D
from keras.layers import GlobalAveragePooling1D,Convolution2D, MaxPooling2D
from keras.layers import Input, Dense, Flatten
# from keras.layers.normalization.batch_normalization_v1 import BatchNormalization
from tensorflow.keras.layers import BatchNormalization
from keras.models import Model
import os,sys
from keras.models import Sequential

import m0_para


def con1D(input_shape,num_class):
    model = models.Sequential()
    model.add(layers.Conv1D(
        input_shape = input_shape,
        filters = 181,
        kernel_size = 5,
        strides = 2,
        padding = 'same',
        activation = 'relu',
        name = 'conv1'
    ))

    model.add(layers.Conv1D(filters =189,kernel_size =5,
                            strides=1,
                            padding='same',activation='relu',
                            kernel_regularizer=regularizers.l2(0.001),
                            name='conv2'))

    model.add(layers.Dropout(0.2))

    model.add(layers.MaxPooling1D(
        pool_size = 8,
        strides = 2,
        padding = 'same',
        name = 'pool1'))

    model.add(layers.Conv1D(89,5,activation='relu',
                            strides=2,
                            padding='same',
                            kernel_regularizer=regularizers.l2(0.001),
                            name='conv3'))

    model.add(layers.Conv1D(55,5,activation='relu',padding='same',
                            strides=2,
                            kernel_regularizer=regularizers.l2(0.001),
                            name="conv4"))

    model.add(layers.Dropout(0.2))

    model.add(layers.MaxPooling1D(
        pool_size = 8,
        strides =3,
        padding = 'same',
        name = 'pool2'))

    model.add(layers.Dropout(0.2))
    model.add(layers.Flatten())
    model.add(layers.Dense(35,activation='softmax'))
    model.add(layers.Dense(num_class,activation='softmax'))

    return model

def con1D_2(input,num_classes):

    x=layers.Conv1D(
        # input_shape = input_shape,##input_shape
        filters = 181,
        kernel_size = 5,
        strides = 1,
        padding = 'same',
        activation = 'relu',
        name = 'conv1'
    )(input)


    x=layers.Conv1D(filters =150,kernel_size =5,
                            strides=1,
                            padding='same',activation='relu',
                            kernel_regularizer=regularizers.l2(0.001),
                            name='conv2')(x)


    x=layers.MaxPooling1D(
        pool_size = 8,# pool_size为 4 或者8  不影响模型参数
        strides = 2,  # (2,2) 可以简写成 2
        padding = 'same',
        name = 'pool1')(x)#池化后变成
    x=layers.Dropout(0.2)(x)

    x=layers.Conv1D(110,5,activation='relu',
                            strides=1,
                            padding='same',
                            kernel_regularizer=regularizers.l2(0.001),
                            name='conv3')(x)

    x=layers.Conv1D(110,5,activation='relu',padding='same',
                            strides=1,
                            kernel_regularizer=regularizers.l2(0.001),
                            name="conv4")(x)
    # x=layers.MaxPooling1D(
    #     pool_size = 4,# pool_size
    #     strides =2,  # (2,2)
    #     padding = 'same',
    #     name = 'pool2')(x)
    # x=layers.Dropout(0.2)(x)
    x=GlobalAveragePooling1D()(x)
    x=layers.Dropout(0.2)(x)

    # x=layers.Flatten()(x)
    x=layers.Dense(85,activation='softmax')(x)
    # x=layers.Dense(85,activation='softmax')(x)
    y=layers.Dense(num_classes,activation='softmax')(x)
    return y

def con1D_3():
    model = Sequential()

    model.add(layers.Conv1D(256, 5, padding='same',
                     input_shape=(216, 1)))
    model.add(Activation('relu'))
    model.add(layers.Conv1D(128, 5, padding='same'))
    model.add(Activation('relu'))
    model.add(Dropout(0.1))
    model.add(layers.MaxPooling1D(pool_size=(8)))
    model.add(layers.Conv1D(128, 5, padding='same', ))
    model.add(Activation('relu'))
    # model.add(Conv1D(128, 5,padding='same',))
    # model.add(Activation('relu'))
    # model.add(Conv1D(128, 5,padding='same',))
    # model.add(Activation('relu'))
    # model.add(Dropout(0.2))
    model.add(layers.Conv1D(128, 5, padding='same', ))
    model.add(Activation('relu'))
    model.add(Flatten())
    model.add(Dense(6))
    model.add(Activation('softmax'))


def get_model_2D(input , num_classes):
    f_size = 1
    x = Convolution2D(48, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(input)
    x = Convolution2D(48, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(x)
    x = BatchNormalization()(x)
    x = Activation('relu')(x)
    x = MaxPooling2D(pool_size=(2, 2))(x)
    x = Dropout(0.5)(x)
    x = Convolution2D(96, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(x)
    x = Convolution2D(96, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(x)
    x = BatchNormalization()(x)
    x = Activation('relu')(x)
    x = MaxPooling2D(pool_size=(2, 2))(x)
    x = Dropout(0.5)(x)
    x = Flatten()(x)
    x = Dense(256)(x)
    x = BatchNormalization()(x)
    x = Activation('relu')(x)
    x = Dropout(0.5)(x)
    x = Dense(num_classes)(x)
    y = Activation('softmax')(x)
    return y

def get_model_2D_small(input , num_classes):
    f_size = 1
    x = Conv2D(48, (3,3), strides=(2,2), kernel_initializer='normal', padding='same')(input)
    x = Conv2D(48, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(x)
    x = BatchNormalization()(x)
    x = Activation('relu')(x)
    x = MaxPooling2D(pool_size=(2, 2), padding='same')(x)
    x = Dropout(0.5)(x)
    x = Conv2D(96, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(x)
    x = Conv2D(48, (f_size,f_size), strides=(f_size,f_size), kernel_initializer='normal', padding='same')(x)
    x = BatchNormalization()(x)
    x = Activation('relu')(x)
    x = MaxPooling2D(pool_size=(2, 2), padding='same')(x)
    x = Dropout(0.5)(x)
    x = Flatten()(x)
    x = Dense(256)(x)
    x = BatchNormalization()(x)
    x = Activation('relu')(x)
    x = Dropout(0.5)(x)
    y = Dense(num_classes, name='out', activation='softmax')(x)

    return y




if __name__ == '__main__':

    model_pic_save=m0_para.model_pic_save
    #
    # ## 1.  con1D_2
    # input=Input(shape=(200, 68))
    # y = con1D_2(input, num_classes=50)
    # model = Model(inputs=input, outputs=y)
    # model.summary()
    #
    #
    #
    # plot_model(model,
    #            to_file=model_pic_save+os.sep+"model_con1D_2.png",
    #            show_shapes=True,
    #            show_layer_names='False',
    #            rankdir='TB')
    # #
    #
    # ## 1.2 con1D
    # m1 = con1D((240, 50), 6)
    # m1.summary()
    # plot_model(m1,
    #            to_file=model_pic_save+os.sep+"model_con1D.png",
    #            show_shapes=True,
    #            show_layer_names='False',
    #            rankdir='TB')
    #
    # ## 2. con2D
    # input = Input(shape=(32, 20, 1), name='the_input')
    # y = get_model_2D(input, num_classes=6)
    # model = Model(inputs=input, outputs=y)
    # model.summary()
    # plot_model(model,
    #            to_file=model_pic_save+os.sep+"model_2D.png",
    #            show_shapes=True,
    #            show_layer_names='False',
    #            rankdir='TB')
    #
    # ## 3. con2D_small
    # # input = Input(shape=(32, 20, 1), name='the_input')
    # input = Input(shape=(200, 68,1), name='the_input')
    # y = get_model_2D_small(input, num_classes=6)
    # model = Model(inputs=input, outputs=y)
    # model.summary()
    # plot_model(model,
    #            to_file=model_pic_save+os.sep+"model_2D_small.png",
    #            show_shapes=True,
    #            show_layer_names='False',
    #            rankdir='TB')