# How to execute tone recognition code

## 1.Configuration Environment
The specific environment has been written in the "requirements.txt" file. You only need to install the files that need 
to execute the code. There is no need to install all the packages in the file.

## 2. The role of each file
* m0_para.py:Record the path where each data is saved, audio feature tags, tone tags and set parameters
* M1_CNN_model.py:1DCNN and 2DCNN models with different parameters are recorded
* M2_ConvLSTM.py:Building models of different types
* M3_load_data_utf8.py:Randomly select a batch of data and iteratively output the data to the model
* M4_get_features:Extract 68 features
* S3_train_data.py:Train a deep learning model
* S4_auc.py:Get the pre-trained weights of the deep learning model
* s8_sklearn_data.py:Generate pretrained weight files for machine learning models
* s9_evaluation.py:Visualize the comparison between our model (1DCNN-BiLSTM) and other models, which is Figure 8 in this paper
* comment_fun.py:Used to save and load files
* deep_learning_evaluate.py:Evaluating indicators AlexNet, ResNet, LSTM, 1DCNN-BiLSTM in classification results and different combination models in ablation study
* sklearn_evaluate.py:Evaluation indicators for SVM,KNN,DT,LR,RF,MLP,CNN+SVM,CNN+LR,LSTM+SVM,LSTM+RF
* ThreadingSafetyIter.py:iterator to use

## 3. Steps
* You need to modify the relevant paths of the above files, which affects whether the code can run normally.
* Execute the S3_train_data.py file and you can get H5 files of different deep learning models. Of course, you can also directly use the H5 files we have trained
* After you have the H5 file of the model, execute the S4_auc file to get the pkl file of the model, which records the accuracy of each tone in the model. You can 
  also output an xlsx or CSV file at the end for evaluation indicators. Of course, the files I gave already have xlsx and CSV files, you can use them directly.
* Execute s8_sklearn_data.py, you can get the pkl file of the machine learning model, and you can also output a CSV file. Of course, you can also directly use the 
  pkl and CSV files I gave
* After you have the pkl files of this article's model (1DCNN-BiLSTM) and the machine learning model, execute the s9_sklearnVSours_train.py file, and you can get 
  the histogram between them, which is Figure 8 in this paper.
* Finally, read the xlsx or CSV file to get the evaluation indicators of each model. The deep learning model executes the deep_learning_evaluate.py file, and the
  machine learning model executes the sklearn_data.py file.

## 4. Precautions
* The Raw Data folder contains the custom dataset (audio file) of this article, which needs to be called with the correct path.
* When reading the code and viewing the label of the "result" file, you may encounter Chinese abbreviations with different tones from the six tones in the manuscript.
  "general" mean "normal","jd" mean "determination","wz" mean "steadiness","fn" mean "angry","yl" mean "stress".
* The previous files are all in the "result" file. You can use them directly. Of course, you can also generate these files by executing the code.
