#
import os
import sys
import keras
sys.path.append(os.getcwd())
sys.path.append(r'D:\hc--document\all text\P7_2_tone')   # Replace with your file path
from comment_fun import save_as_ob
import numpy as np
from M4_get_features import get_feature_by_pyAudio

def get_data(files,feature_args,max_pad_size,audio_use_seconds):
    input_data_shape = feature_args['input_data_shape']
    features_position_list = feature_args['feature_position_list']
    win = feature_args['win']
    step = feature_args['step']
    # audio_use_seconds = feature_args['audio_use_seconds']
    # max_pad_size = feature_args['max_pad_size']
    mean_col_num = max_pad_size / input_data_shape
    start_seconds = feature_args['start_seconds']
    save_as_pickle = feature_args['save_as_pickle']
    get_max = feature_args['get_max']
    if type(files) is list:
        x = np.zeros((len(files), input_data_shape, len(features_position_list)), dtype=np.float64)
    else:
        x=np.zeros((1, input_data_shape, len(features_position_list)), dtype=np.float64)
        files=[files]
    for i, file in enumerate(files):
        feactures, _ = get_feature_by_pyAudio(file_in=file,
                                              mean_col_num=mean_col_num,
                                              input_data_shape=input_data_shape,
                                              win=win,
                                              step=step,
                                              max_pad_size=max_pad_size,
                                              use_seconds=audio_use_seconds,
                                              start_seconds=start_seconds,
                                              save_as_pickle=save_as_pickle,
                                              get_max=get_max)
        features_use = feactures[:, features_position_list]
        x[i] = np.array(features_use)
    return x



def get_label(file_path,feature_args,max_pad_size,audio_use_seconds):

    print(file_path)
    try:
        data_i = get_data(files=file_path,
                          feature_args=feature_args,
                          max_pad_size=max_pad_size,
                          audio_use_seconds=audio_use_seconds)
        result = model.predict(data_i)  #
        # print(result)
        return result.tolist()[0]
        # index = np.argmax(result, axis=1)[0]
        # return list(labels.keys())[index]
    except Exception as e:
        return e
    # print(list(labels.keys())[index])


def get_label_str(label_list,label_dict):
    if type(label_list) is list:
        index = label_list.index(max(label_list))
        return list(label_dict.keys())[index]
    else:
        return label_list


def get_data_2(label_df, path_wav_train):
    tone_type_in = label_df['tone_type_in']
    save_file_lable_info = label_df['save_file_name']
    file_path_lable = path_wav_train + os.sep + tone_type_in + os.sep + save_file_lable_info
    label_file = save_as_ob(file_path_lable, False)
    trian_file_label = label_file.loc[label_file['is_validation'] == 0]  # .iloc[:100,:]
    validation_file_label = label_file.loc[label_file['is_validation'] == 1]  # .iloc[:20,:]
    # print(
    #     f"data shape:{label_file.shape[0]}- train_data :{trian_file_label.shape[0]}--val_shape:{validation_file_label.shape[0]}")
    return tone_type_in, trian_file_label, validation_file_label



if __name__ == '__main__':

    import m0_para

    # 1. Import Data
    save_file_lable_info = m0_para.all_label['save_file_name']
    file_path_lable = m0_para.path_wav_train + os.sep +save_file_lable_info
    data = save_as_ob(file_path_lable, False)
    # data=data.iloc[0:50,]


    # 2. Import model
    model = keras.models.load_model(m0_para.model_for_predict_h5)

    # 3. Forecast data
    print(data.columns)

    # switch path
    def get_new_path(raw, new_dict):
        parts = raw.split("\\")
        new_path = new_dict + "\\" + "\\".join(parts[-2:])
        return new_path


    data['file_path_wav'] = data['file_path_wav'].apply(lambda x:
                                                        get_new_path(raw=x,
                                                                     new_dict=r"D:\hc--document\all text\P8_medical\thesis_dataset\use_wav_raw"))  # Replace with your dataset path

    data['label_predict_list'] = data['file_path_wav'].apply(lambda x: get_label(x,
                                                                                 m0_para.feature_args,
                                                                                 m0_para.fit_pars1_1['max_pad_size'],
                                                                                 m0_para.fit_pars1_1[
                                                                                     'audio_use_seconds']))

    data['label_predict_str'] = data['label_predict_list'].apply(lambda x: get_label_str(x, m0_para.all_label['label']))

    data['auc_right'] = data.apply(lambda x: 1 if x['new_label'] == x['label_predict_str'] else 0, axis=1)

    # 4. Save predicted data
    save_as_ob(m0_para.save_auc_predict_path, True, data)

    # 5. Classify and view the prediction accuracy of different tones.
    def get_right_precent(x):
        is1=len(x[x==1])
        return is1/len(x)

    data_g=data.groupby(['is_validation','new_label'])['auc_right'].agg(get_right_precent).reset_index()
    save_as_ob(m0_para.save_auc_path,True,data_g)
    print(data_g)


    # 6. overall accuracy
    data=save_as_ob(m0_para.save_auc_predict_path,False)
    data_g2=data.groupby(['is_validation'])['auc_right'].agg(get_right_precent).reset_index()
    print(data_g2)


