
#
import os,sys

# "general" means "normal","fn" means "angry","wz" means "steadiness" or "steady","rouhe" means "tenderness", "yl" means "stress"

train_data=r'D:\hc--document\all text\P8_medical\step8_trian'  # Replace with your file path

#

features = ['zcr', 'energy', 'energy_entropy', 'spectral_centroid', 'spectral_spread', 'spectral_entropy',
            'spectral_flux',
            'spectral_rolloff', 'mfcc_1', 'mfcc_2', 'mfcc_3', 'mfcc_4', 'mfcc_5', 'mfcc_6', 'mfcc_7', 'mfcc_8',
            'mfcc_9',
            'mfcc_10', 'mfcc_11', 'mfcc_12', 'mfcc_13', 'chroma_1', 'chroma_2', 'chroma_3', 'chroma_4', 'chroma_5',
            'chroma_6',
            'chroma_7', 'chroma_8', 'chroma_9', 'chroma_10', 'chroma_11', 'chroma_12', 'chroma_std', 'delta zcr',
            'delta energy',
            'delta energy_entropy', 'delta spectral_centroid', 'delta spectral_spread', 'delta spectral_entropy',
            'delta spectral_flux',
            'delta spectral_rolloff', 'delta mfcc_1', 'delta mfcc_2', 'delta mfcc_3', 'delta mfcc_4', 'delta mfcc_5',
            'delta mfcc_6', 'delta mfcc_7', 'delta mfcc_8', 'delta mfcc_9', 'delta mfcc_10', 'delta mfcc_11',
            'delta mfcc_12',
            'delta mfcc_13', 'delta chroma_1', 'delta chroma_2', 'delta chroma_3', 'delta chroma_4', 'delta chroma_5',
            'delta chroma_6',
            'delta chroma_7', 'delta chroma_8', 'delta chroma_9', 'delta chroma_10', 'delta chroma_11',
            'delta chroma_12', 'delta chroma_std']

used_feature = features

sys.path.append(r"D:\hc--document\all text")   # Replace with your file path

path_wav_train = r"D:\hc--document\all text\P8_medical\step8_trian"   # Replace with your file path




all_label = {
    "degree_use": ["1"],  # To what extent should be used as training?
    "label": {'general': 0, 'fn': 1, 'jd': 2, 'wz': 3, "rouhe": 4, "yl": 5},
    # 2. Parameters during training
    "types_num": 6,
    # Proportion used for training
    'test_percent': 0.8,
    # randomly selected seeds
    "random_seed": 1,
    "save_file_name": "s2_random_trian.pkl",
}



def get_used_feature_position_list(used_feature, features):
    position_list = []
    for i in used_feature:
        position_list.append(features.index(i))
    return position_list


fit_pars1_1 = {
    # 1 Audio length characteristics
    # 1) How long of audio to use for training
    "audio_use_seconds": 15,
    "max_pad_size": 600,  # audio length

    # 2)Number of incoming audios per batch
    "batch_size": 64,  # 64,128,256
    # 3) number of labels
    "types_num": 6,  # Number of categories, low/medium/high/very high/very high
    # 4) Number of iterations
    "num_epochs": 200,
    # 5 )multi-process training
    "use_multiprocessing": False,
    # 6)
    "workers": 5,  # Number of multiple processes
    # 2 Define loss function
    # 2.1) loss
    "loss": 'categorical_crossentropy',
    # 2.2) optimizer
    "optimizer": 'adam',  # adam,  sgd,
    # 2.3) 优化策略
    "metrics": ['accuracy'],
    'learning_rate_mode': 1,
    "learning_rate_dict":{100:0.0001,200:0.00001,300:0.000001},
    # "lr_schedule": lambda epoch: 0.0001 * 0.4 ** epoch,
    # 3. Import the previous model to continue training
    "load_ex_modol": True,
    "model_args": {'dropout': 0.2, "dropout2": 0.2, "dropout3": 0.1, "dropout4": 0.3},     #0.1,0.2,0.3
    # "model_args": {},
    # 4. Save parameters to a file
    "args_info_save": 'args_info.txt',

    # 3.first few attempts
    # 10s
    "version_name": "version1_batchsize64_68fecture_modelv4nodropout_Lr1_15s",
    "save_file_name": "s2_random_trian.pkl"

}



feature_args = {
    # Column name of the column in which the file name is located
    "file_path": 'file_path_wav',
    "label_col_name": "label_score",
    # 0) The starting seconds of the read audio file path
    "start_seconds": 0,
    # 1) How long of audio to use for training
    "audio_use_seconds": 15,
    # 2) Step size and serial port
    "step": 0.0250,
    "win": 0.050,  # 0.05
    # 3)
    # The characteristic width of 15s of data is: (68, 599)
    "max_pad_size": 600,  # audio length
    # 4) Data characteristics data set compression factor. For data that is too long, how many adjacent columns are merged and averaged?
    "input_data_shape": 200,
    "get_max": False,  # When it is True, the maximum value of adjacent columns is taken, and when it is False, the average value is taken.
    "use_all_col": False,  # No data compression

    # 5) save_as_pickle: When generating features from files, whether to save them as pickle files
    "save_as_pickle": False,
    # 6) features_postion_list
    "feature_position_list": get_used_feature_position_list(used_feature, features),
}


#######  Specify the final location where the model will be saved

# Documents recording the training process
model_run_path = path_wav_train + os.sep + "saved_models"
# Model save path
last_model_path = model_run_path + os.sep + 'last_models'

###############################

# 1) Model used for prediction
model_for_predict = r'D:\hc--document\all text\P8_medical\step8_trian\version1_batchsize64_68fecture_modelv4nodropout_Lr1_15s'  # Replace with your file path
model_for_predict_h5=model_for_predict+os.sep+"model_dropout_0.1.h5"
# labels = {'general': 0, 'angry': 1, 'serious': 2, 'calm': 3, "gentle": 4, "fearful": 5}
labels ={'general': 0, 'fn': 1, 'jd': 2, 'wz': 3, "rouhe": 4, "yl": 5}
labels_EN ={'normal': 0, 'angry': 1, 'steadiness': 2, 'determination': 3, "tenderness": 4, "stress": 5}



# 2) Save the predicted model
save_auc_predict_path=path_wav_train+os.sep+"s3_predict.pkl"
# save_auc_predict_path=path_wav_train+os.sep+"s3_predict_batch256.pkl"
# save_auc_predict_path=path_wav_train+os.sep+"s3_predict_bilstm_layer2.pkl"
# save_auc_predict_path=path_wav_train+os.sep+"s3_predict_dropout0.1.pkl"
# save_auc_path=path_wav_train+os.sep+"s4_auc.pkl"
# save_auc_path=path_wav_train+os.sep+"s4_auc_batch256.pkl"
# save_auc_path=path_wav_train+os.sep+"s4_auc_bilstm_layer2.pkl"
save_auc_path=path_wav_train+os.sep+"s4_auc_dropout0.1.pkl"

path_save_base = r"D:\hc--document\all text\P8_medical"  # Replace with your file path


#################################

features_new = ['zcr', 'energy', 'energy_entropy', 'spectral_centroid', 'spectral_spread', 'spectral_entropy',
            'spectral_flux',
            'spectral_rolloff', 'mfcc_1', 'mfcc_2', 'mfcc_3', 'mfcc_4',
            'mfcc_5', 'mfcc_6', 'mfcc_7', 'mfcc_8',
            'mfcc_9',
            'mfcc_10', 'mfcc_11', 'mfcc_12', 'mfcc_13',
            'chroma_1', 'chroma_2', 'chroma_3', 'chroma_4', 'chroma_5',
            'chroma_6',
            'chroma_7', 'chroma_8', 'chroma_9', 'chroma_10', 'chroma_11',
            'chroma_12', 'chroma_std', 'delta_zcr',
            'delta_energy',
            'delta_energy_entropy', 'delta_spectral_centroid',
            'delta_spectral_spread', 'delta_spectral_entropy',
            'delta_spectral_flux',
            'delta_spectral_rolloff', 'delta_mfcc_1', 'delta_mfcc_2',
            'delta_mfcc_3', 'delta_mfcc_4', 'delta_mfcc_5',
            'delta_mfcc_6', 'delta_mfcc_7', 'delta_mfcc_8', 'delta_mfcc_9',
            'delta_mfcc_10', 'delta_mfcc_11',
            'delta_mfcc_12',
            'delta_mfcc_13', 'delta_chroma_1', 'delta_chroma_2', 'delta_chroma_3', 'delta_chroma_4', 'delta_chroma_5',
            'delta_chroma_6',
            'delta_chroma_7', 'delta_chroma_8', 'delta_chroma_9', 'delta_chroma_10', 'delta_chroma_11',
            'delta_chroma_12', 'delta_chroma_std']

#################################
# sklearn
#1) Save 68 features
svm_trian_data=path_save_base+os.sep+r"step10_svm\s1_data_for_sklearn.pkl"

# 2) Drawing reservation
pic_save_name=r'D:\hc--document\all text\P8_medical\step10_svm\s2_pic.png'

label_CN= [ "正常",'坚定', "稳重", '柔和', '压力','愤怒', "平均识别率"]
label_EN= [ "normal",'determination', "steadiness", 'tenderness', 'stress','angry', "average"]
label_str= { 0:'正常',  1:'愤怒',  2:'坚定',  3:'稳重',  4:"柔和",  5:"压力"}
label_str_EN= { 0:'normal',  1:'angry',  2:'steadiness',  3:'determination',  4:"tenderness",  5:"stress"}
label_str2= {"general":'正常',  "fn":'愤怒',  "jd":'坚定',  'wz':'稳重',  "rouhe":"柔和",  "yl":"压力"}
label_str2_EN= {"general":'normal',  "fn":'angry',  "jd":'determination',  'wz':'steadiness',  "rouhe":"tenderness",  "yl":"stress"}
label_str_order= { '正常':0,  '愤怒':5,  '坚定':1,  '稳重':2,  "柔和":3,  "压力":4}
label_str_order_EN= { 'normal':0,  'angry':5,  '坚定':1,  '稳重':2,  "tenderness":3,  "stress":4}
