
import os
import sys
sys.path.append(os.getcwd())
sys.path.append(r'D:\hc--document\all text\P7_2_tone')  # Replace with your file path
import numpy as np

from comment_fun import save_as_ob
from pyAudioAnalysis import ShortTermFeatures as aF
from pyAudioAnalysis import audioBasicIO as aIO


#1. Get the audio feature set
def get_features(file,start_seconds,audio_use_seconds,win,step):
    #file = file.replace('wav_raw', 'step3_wav_raw')
    print(file)
    # Calculate the average of 68 features
    fs, s = aIO.read_audio_file(file)
    s = s[start_seconds * fs: audio_use_seconds * fs]

    # Extract short-term signals, win and step represent the window and step size, f is a matrix of [68, segment length], and fn is the feature name
    [f, fn] = aF.feature_extraction(s, fs, int(fs * win), int(fs * step))
    f = f.T
    np.mean(f)
    return f.mean(axis=0).tolist()

if __name__ == '__main__':

    import m0_para

    path_wav_train = m0_para.path_wav_train
    fit_pars, feature_args = m0_para.fit_pars1_1, m0_para.feature_args
    win = feature_args['win']
    step = feature_args['step']
    audio_use_seconds = fit_pars['audio_use_seconds']
    start_seconds = feature_args['start_seconds']
    max_pad_size=fit_pars['max_pad_size']

    # 1. The data set to be predicted
    file_path_lable = path_wav_train + os.sep + fit_pars["save_file_name"]
    data = save_as_ob(file_path_lable, False)
    # data=data.iloc[1:10,]
    data['new_label'].value_counts()


    # switch path
    def get_new_path(raw, new_dict):
        parts = raw.split("\\")
        new_path = new_dict + "\\" + "\\".join(parts[-2:])
        return new_path


    data['file_path_wav'] = data['file_path_wav'].apply(lambda x:
                                                       get_new_path(raw=x,new_dict =r"D:\hc--document\all text\P8_medical\thesis_dataset\use_wav_raw")) # Replace with your dataset path

    # 2. Get 68 features
    data['feature_list'] = data['file_path_wav'].apply(lambda x:
                                                     get_features(x,start_seconds,audio_use_seconds,win,step))

    for i,v in enumerate(m0_para.features_new):
        data[v]=data["feature_list"].apply(lambda x: x[i])

    save_as_ob(m0_para.svm_trian_data,True,data)     # All machine learning models can be used
